<?php

class PageController extends RController
{

    /**
     * @return array action filters
     */
    public function filters()
    {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id)
    {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate()
    {
        $model = new Page;
        if (Yii::app()->options->get('I18N_MULTILINGUAL', 0) == 0) {
            $model->language = Yii::app()->language;
        }
        $model->layout = 'main';
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Page'])) {
            $model->attributes = $_POST['Page'];


            $baseUrl = Yii::app()->basePath;
            $model->attach = CUploadedFile::getInstance($model, 'attach');
            if ($model->attach != null && $model->validate(['attach'])) {
                $file = $model->attach;
                $filename = uniqid('attachment') . '.pdf';
                $test = $baseUrl . '/../uploads/Page/files/' . $filename;
                $model->attachment_url = $filename;
                // $model->attachment_title= $filename;
                $file->saveAs($test);
            }


            $model->create_datetime = date('Y-m-d');
            $model->update_datetime = date('Y-m-d');
            ImageHelper::resize($model, 'image');
            if ($model->save()) {

                Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully created.'));
                $this->redirect(array('admin'));
            }
        }
        $this->render('create', array(
            'model' => $model,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id)
    {
        $model = $this->loadModel($id);
        $old_pdf = $model->attachment_url;
        $old_value = $model->image;
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Page'])) {
            // $old_value = $model->image;
            $model->attributes = $_POST['Page'];
            ImageHelper::resize($model, 'image', $old_value);


            $baseUrl = Yii::app()->basePath;
            $model->attach = CUploadedFile::getInstance($model, 'attach');
            if ($model->attach != null && $model->validate(['attach'])) {
                $file = $model->attach;
                $filename = uniqid('attachment') . '.pdf';
                $test = $baseUrl . '/../uploads/Page/files/' . $filename;
                $model->attachment_url = $filename;

                $file->saveAs($test);
            } else {
                $model->attachment_url = $old_pdf;
            }



            if ($model->validate()) {
                if ($model->image == null && $old_value != null)
                    $model->image = $old_value;
                if ($model->save(false)) {

                    Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully updated.'));
                    $this->redirect(array('admin'));
                }
            }
        }
        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id)
    {
        $this->loadModel($id)->delete();
        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }


    public function actionDelete_pdf($id)
    {
        $model = $this->loadModel($id);
        // $model->scenario='deletepdf';
        $model->attachment_url = Null;
        if ($model->save()) {
            $this->redirect(array('admin'));
        } else {
            var_dump($model->getErrors());
        }
    }

    /**
     * Lists all models.
     */
    public function actionIndex()
    {
        $dataProvider = new CActiveDataProvider('Page');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin()
    {
        $model = new Page('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Page']))
            $model->attributes = $_GET['Page'];
        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return Page the loaded model
     * @throws CHttpException
     */
    public function loadModel($id)
    {
        $model = Page::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param Page $model the model to be validated
     */
    protected function performAjaxValidation($model)
    {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'page-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }
}
